import greenfoot.*; 

/**
 * CatCannon is a purple cat that vomits Rainbow Hairballs 
 * when the space bar is pressed.
 * It can also move left and right, and diagonally up into the sky, 
 * which is weird.
 * 
 * @author Gina Giommi
 * @version Ver.1
 */
public class CatCannon extends Actor
{
    private GreenfootImage cat1 = new GreenfootImage("catCannon2.png");
    private GreenfootImage cat2 = new GreenfootImage("catCannon.png");
    
    /**
     * Default CatCannon for placing a cat in the preset location in the world.
     */
    public CatCannon()
    {
        // default constructor
    }

    /**
     * Create a CatCannon at a different location than the default 77, 352.
     * Place it anywhere in the world by passing integers to the locationX and
     * locationY parameters.
     * @param: Location of x coordinate.
     * @param: Location of Y coordinate.
     */
    public CatCannon(int locationX, int locationY)
    {
        setLocation(locationX, locationY);
    }

    /**
     * Act - do whatever the CatCannon wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if(Greenfoot.isKeyDown("up")) {
            turn(-1);
        }
        if(Greenfoot.isKeyDown("down")) {
            turn(+1);
        }
        if(Greenfoot.isKeyDown("right")) {
            move(1);
        }
        if(Greenfoot.isKeyDown("left")) {
            move(-1);
        }
        if ("space".equals(Greenfoot.getKey()))
        {
            vomit();
            ProjectilePlanet planet = (ProjectilePlanet) getWorld();
            planet.addBall();
        }
    }

    /**
     * Change the image to another leaf image. This toggles back and
     * forth between two images.
     */
    public void changeCatImage()
    {
        ProjectilePlanet planet = (ProjectilePlanet) getWorld();
        if (planet.ballCounter == 0) 
        {
            setImage(cat1);
        }
        else {
            setImage(cat2);
        }
    }

    private void vomit()
    {
        Greenfoot.playSound("meow.wav");
        int angle = getRotation() - 36;
        RainbowHairball ball = new RainbowHairball(new Vector(angle, 9));
        getWorld().addObject(ball, getX(), getY());
        ball.setRotation(angle);
        ball.move(25);
    }
}