import greenfoot.*;  
import java.util.List;

/**
 * Write a description of class ProjectilePlanet here.
 * 
 * @author Gina Giommi
 * @version Ver.1
 */
public class ProjectilePlanet extends World
{ 

    public static final int GROUND_HEIGHT = 360;
    public static final Vector GRAVITY = new Vector(0.0, 0.2);

    public static int ballCounter = 0;

    private GreenfootImage frog1 = new GreenfootImage("lilFrog1.png");
    private GreenfootImage frog2 = new GreenfootImage("lilFrog2.png");

    /**
     * Constructor for objects of class ProjectilePlanet.
     * 
     */
    public ProjectilePlanet()
    {    

        super(600, 400, 1); 
        setup();

        prepare();
    }

    public void addBall()
    {
        ballCounter++;
        informActors();
    }

    public void subtractBall()
    {
        ballCounter--;
        informActors();
    }

    public void informActors()
    {
        List<LilFrog> frogs = getObjects(LilFrog.class);

        for (LilFrog frog : frogs)
        {
            frog.changeImage();
        }
        List<CatCannon> cats = getObjects(CatCannon.class);

        for (CatCannon cat : cats)
        {
            cat.changeCatImage();
        }
    }

    /**
     * Set up
     */
    public void setup()
    {
        for (int i = 0; i < 19; i++)
        {
            int x = i * 40 + 20;
            int y = GROUND_HEIGHT + 20;
            addObject(new GrassTile(), x, y);
        }

    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        CatCannon cat = new CatCannon();
        addObject(cat,77,352);
        LilFrog frog1 = new LilFrog();
        addObject(frog1,270,352);
        LilFrog frog2 = new LilFrog();
        addObject(frog2,400,352);
        LilFrog frog3 = new LilFrog();
        addObject(frog3,500,352);
        cat.setLocation(77,344);
    }
}
